/*Canopy - The next generation of stoner streaming software
Copyright (C) 2024-2025 Rainbownapkin and the TTN Community

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

//local imports
const rememberMeModel = require('../../../schemas/user/rememberMeSchema');
const sessionUtils = require('../../../utils/sessionUtils');
const {exceptionHandler} = require('../../../utils/loggerUtils');
const {validationResult, matchedData} = require('express-validator');

module.exports.post = async function(req, res){
    if(req.session.user){
        try{
            sessionUtils.killSession(req.session);

            //Check validation results
            const validResult = validationResult(req);

            //if we don't have errors
            if(validResult.isEmpty()){
                //Pull sanatzied/validated data
                const data = matchedData(req); 
                
                //If the user has a remember me token id they've submitted with the request
                if(data.rememberme != null && data.rememberme.id != null){
                    //Find the associated token and nuke it
                    await rememberMeModel.deleteOne({id: data.rememberme.id})
                }
            }

            //Clear out remember me tokens
            res.clearCookie("rememberme.id");
            res.clearCookie("rememberme.token");

            //Return status
            return res.sendStatus(200);
        }catch(err){
            return exceptionHandler(res, err);
        }
    }else{
        res.status(400);
        return res.send()
    }
}